/*=================================================================*/
/*              SNAS Family addition                               */
/*=================================================================*/

insert into HABDBSYNC.P_ARRAY_DEVICE_CONFIG_META (ID,MODEL,TYPE,CONFIG_KEY,DEFAULT_VALUE,CONFIG_TYPE,IS_MANDTORY,INFO_TEXT)  values('ARRAY_SNAS_IP','SNAS','ARRAY','P_ARRAY_CONFIG.DEVICE_MANAGER',NULL,'STRING',1,null);
insert into HABDBSYNC.P_ARRAY_DEVICE_CONFIG_META (ID,MODEL,TYPE,CONFIG_KEY,DEFAULT_VALUE,CONFIG_TYPE,IS_MANDTORY,INFO_TEXT)  values('ARRAY_SNAS_USERNAME','SNAS','ARRAY','P_ARRAY_CONFIG.USERNAME','(NULL)','STRING',1,null);
insert into HABDBSYNC.P_ARRAY_DEVICE_CONFIG_META (ID,MODEL,TYPE,CONFIG_KEY,DEFAULT_VALUE,CONFIG_TYPE,IS_MANDTORY,INFO_TEXT)  values('ARRAY_SNAS_PASSWD','SNAS','ARRAY','P_ARRAY_CONFIG.PASSWD',NULL,'PASSWORD_STRING',1,null);

insert into HABDBSYNC.P_UI_RESOURCE (ID)  values('ARRAY_SNAS_IP');
insert into HABDBSYNC.P_UI_RESOURCE (ID)  values('ARRAY_SNAS_USERNAME');
insert into HABDBSYNC.P_UI_RESOURCE (ID)  values('ARRAY_SNAS_PASSWD');

insert into HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY)  values('ARRAY_SNAS_IP','en_US','InfoScale Access IP/Name');
insert into HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY)  values('ARRAY_SNAS_USERNAME','en_US','User Name');
insert into HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY)  values('ARRAY_SNAS_PASSWD','en_US','Password');

insert into HABDBSYNC.P_CONFIG_VENDOR_MAP (VENDOR,MODEL,METHOD,DISCOVERY_METHOD,TYPE,INFO_TEXT_ID)
values('Veritas','InfoScale Access','SNAS','Using SSH Communication','ARRAY','Veritas_INFO_TEXT');
INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID)  VALUES('Veritas_INFO_TEXT');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY)  VALUES('Veritas_INFO_TEXT','en_US','InfoScale Access is a resilient and high-performance clustered network-attached storage (NAS) software solution. <br>Based on Veritas Cluster File System (CFS) technology, InfoScale Access is a complete solution for multi-protocol access.<br>InfoScale Access gives you the flexibility to deploy on any commodity x86 server from the vendor of your choice.<br> ');


/*=================================================================*/
/*              SNAS Array schema                                  */
/*=================================================================*/


/*==============================================================*/
/* Table: P_ARRAY_NODE_INTF_ADDR                                */
/*==============================================================*/
drop table if exists P_ARRAY_NODE_INTF_ADDR;

create table P_ARRAY_NODE_INTF_ADDR (
   IP           VARCHAR(128)         not null,
   NETMASK	VARCHAR(128)         not null,
   NODE_ID      VARCHAR(128)             null,
   DEV_NAME	VARCHAR(128)         not null,
   TYPE		VARCHAR(128)         not null,
   STATUS       VARCHAR(128)		 null,
   TAG		VARCHAR(128)		 null,
   constraint PK_P_ARRAY_NODE_INTF_ADDR primary key (IP),
   constraint FK_P_ARR_SUBSYS_NODES foreign key (NODE_ID)
	  references P_ARRAY_SUBSYSTEM_NODES (ID)
	  on delete cascade on update restrict
);
GRANT ALL ON TABLE P_ARRAY_NODE_INTF_ADDR TO habdbsync;
GRANT ALL ON TABLE P_ARRAY_NODE_INTF_ADDR TO habgui;
GRANT SELECT ON TABLE P_ARRAY_NODE_INTF_ADDR TO habguest;
SELECT UPSERTRULE('P_ARRAY_NODE_INTF_ADDR');

ALTER table HABDBSYNC.P_ARRAY_SUBSYSTEM
    drop IF EXISTS VERSION,
    drop IF EXISTS UPGRADABLE;

ALTER table HABDBSYNC.P_ARRAY_SUBSYSTEM
    add VERSION varchar(32) default 'None',
    add UPGRADABLE boolean default 'false';


alter table HABDBSYNC.P_ARRAY_PDEV
    drop IF EXISTS  PID,
    drop IF EXISTS  USAGE;

alter table HABDBSYNC.P_ARRAY_PDEV
    add PID             varchar(32) default 'None', 
    add USAGE           varchar(32) default 'None'; 


alter table HABDBSYNC.P_ARRAY_PDEV_NODES
    drop IF EXISTS  IS_EXPORT;

alter table HABDBSYNC.P_ARRAY_PDEV_NODES
    add IS_EXPORT        smallint    null;
SELECT UPSERTRULE('P_ARRAY_PDEV_NODES');

alter table HABDBSYNC.P_ARRAY_NAS_FILESYSTEM
    drop IF EXISTS SHARE,
    drop IF EXISTS CACHE_ID;


alter table HABDBSYNC.P_ARRAY_NAS_FILESYSTEM
    add SHARE           varchar(32) default 'None',
    add CACHE_ID        varchar(32) default 'None';


alter table HABDBSYNC.P_ARRAY_NAS_SHARE 
    drop IF EXISTS SUBTYPE;

alter table HABDBSYNC.P_ARRAY_NAS_SHARE 
   add SUBTYPE varchar(32) default 'None';

/*==============================================================*/
/* Table: P_ARRAY_USER_ACCOUNT                               */
/*==============================================================*/
drop table if exists P_ARRAY_USER_ACCOUNT;

create table P_ARRAY_USER_ACCOUNT (
	ID 			VARCHAR(128)         not null,
	SHARE_ID 	VARCHAR(128)         null,
	SUBSYS_ID   VARCHAR(128)         not null,
	NAME		VARCHAR(128)         null,
	ACCESS_KEY	VARCHAR(128)         null,
	SECRET_KEY	VARCHAR(128)         null,
	TYPE		VARCHAR(128)	     not null,
	constraint PK_P_ARRAY_USER_ACCOUNT primary key (ID),
    constraint FK_P_ARRAY_SUBSYS foreign key (SUBSYS_ID) 
      references P_ARRAY_SUBSYSTEM (ID) on delete cascade on update restrict
);
GRANT ALL ON TABLE P_ARRAY_USER_ACCOUNT TO habdbsync;
GRANT ALL ON TABLE P_ARRAY_USER_ACCOUNT TO habgui;
GRANT SELECT ON TABLE P_ARRAY_USER_ACCOUNT TO habguest;
SELECT UPSERTRULE('P_ARRAY_USER_ACCOUNT');

/*==============================================================*/
/* Table: P_ARRAY_SCHEDULE                              */
/*==============================================================*/

drop table if exists P_ARRAY_SCHEDULE;

create table P_ARRAY_SCHEDULE (
   ID           VARCHAR(128)         not null,
   SUBSYS_ID    VARCHAR(128)         not null,
   NAME         VARCHAR(128)         not null,
   TYPE         VARCHAR(128)         not null,
   MINUTE       VARCHAR(128)         not null,
   HOUR         VARCHAR(128)         not null,
   DAY          VARCHAR(128)         not null,
   MONTH        VARCHAR(128)         not null,
   WEEKDAY      VARCHAR(128)         not null,
   constraint PK_P_ARRAY_SCH primary key (ID),
   constraint FK_P_ARR_SUBSYS foreign key (SUBSYS_ID)
      references P_ARRAY_SUBSYSTEM (ID)
      on delete cascade on update restrict
);
GRANT ALL ON TABLE P_ARRAY_SCHEDULE TO habdbsync;
GRANT ALL ON TABLE P_ARRAY_SCHEDULE TO habgui;
GRANT SELECT ON TABLE P_ARRAY_SCHEDULE TO habguest;
SELECT UPSERTRULE('P_ARRAY_SCHEDULE');

/*==============================================================*/
/* Table: P_ARRAY_NAS_FS_SNAPSHOT                               */
/*==============================================================*/

drop table if exists P_ARRAY_NAS_FS_SNAPSHOT;

create table P_ARRAY_NAS_FS_SNAPSHOT (
   ID           VARCHAR(128)         not null,
   SUBSYS_ID    VARCHAR(128)         not null,
   FS_ID        VARCHAR(128)         not null,
   NAME         VARCHAR(128)         not null,
   STATUS       VARCHAR(128)         not null,
   CTIME        VARCHAR(128)         not null,
   MTIME        VARCHAR(128)         not null,
   FLAGS        VARCHAR(128)         not null,
   SIZE         VARCHAR(128)         not null,
   SCHEDULE_ID  VARCHAR(128)         null,
   constraint PK_P_ARRAY_SNAP primary key (ID),
   constraint FK_P_ARR_NAS_FS foreign key (FS_ID) references P_ARRAY_NAS_FILESYSTEM (ID),
   constraint FK_P_ARR_SUBSYS foreign key (SUBSYS_ID) references P_ARRAY_SUBSYSTEM (ID)
   on delete cascade on update restrict
);
GRANT ALL ON TABLE P_ARRAY_NAS_FS_SNAPSHOT TO habdbsync;
GRANT ALL ON TABLE P_ARRAY_NAS_FS_SNAPSHOT TO habgui;
GRANT SELECT ON TABLE P_ARRAY_NAS_FS_SNAPSHOT TO habguest;
SELECT UPSERTRULE('P_ARRAY_NAS_FS_SNAPSHOT');

/*==============================================================*/
/* Add pool creation permission                                 */
/*==============================================================*/
insert into P_OPER_ROLE_DEF values('create_pool', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create storage pool');

/*==============================================================*/
/* Add pool deletion permission                                 */
/*==============================================================*/
insert into P_OPER_ROLE_DEF values('destroy_pool', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Destroy storage pool');

/*==============================================================*/
/* Add share creation permission                                 */
/*==============================================================*/
insert into P_OPER_ROLE_DEF values('create_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create share');

/* For each protocol, need individial row in P_OPER_ROLE_DEF and keep display_name matches the name in template file */
insert into P_OPER_ROLE_DEF values('add_nfs_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create NFS share');

insert into P_OPER_ROLE_DEF values('add_cifs_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create CIFS share');

insert into P_OPER_ROLE_DEF values('add_s3_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create S3 share');

insert into P_OPER_ROLE_DEF values('add_nfs_s3_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create NFS and S3 share');

/*==============================================================*/
/* Add share deletion permission                                 */
/*==============================================================*/
insert into P_OPER_ROLE_DEF values('destroy_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Destroy share');

insert into P_OPER_ROLE_DEF values('destroy_nfs_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Destroy NFS share');

insert into P_OPER_ROLE_DEF values('destroy_cifs_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Destroy CIFS share');

insert into P_OPER_ROLE_DEF values('destroy_s3_share', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Destroy S3 share');

insert into P_OPER_ROLE_DEF values('add_nfs_permission', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Add NFS Permission');

insert into P_OPER_ROLE_DEF values('remove_nfs_permission', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Remove NFS permission');

insert into P_OPER_ROLE_DEF values('s3_account_add', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Add S3 share account');

insert into P_OPER_ROLE_DEF values('s3_account_delete', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Delete S3 share account');

insert into P_OPER_ROLE_DEF values('cifs_share_allow', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Allow CIFS user');

insert into P_OPER_ROLE_DEF values('cifs_share_remove', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Remove CIFS user');

insert into P_OPER_ROLE_DEF values('cifs_share_deny', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Deny CIFS user');


/*==============================================================*/
/* Create new views                                             */
/*==============================================================*/
/*
 * 1.array_view_pdev_nodes_r
 */
-- View: array_view_pdev_nodes_r

-- DROP VIEW array_view_pdev_nodes_r;

CREATE OR REPLACE VIEW array_view_pdev_nodes_r AS 
 SELECT p_array_pdev_nodes.subsys_id,
    p_array_pdev_nodes.node_id,
    p_array_pdev_nodes.pdev_id,
    p_array_pdev_nodes.status,
    p_array_pdev_nodes.is_export
 FROM p_array_pdev_nodes;

ALTER TABLE array_view_pdev_nodes_r
  OWNER TO habdbsync;
GRANT ALL ON TABLE array_view_pdev_nodes_r TO habdbsync;
GRANT ALL ON TABLE array_view_pdev_nodes_r TO habgui;
GRANT SELECT ON TABLE array_view_pdev_nodes_r TO habguest;

/*
 * 3. vom_view_storage_array_fss_pdev
 */
-- View: vom_view_storage_array_fss_pdev

DROP VIEW if exists vom_view_storage_array_fss_pdev;

CREATE OR REPLACE VIEW vom_view_storage_array_fss_pdev AS 
 SELECT array_view_pdev_r.id,
    array_view_pdev_r.name,
    array_view_subsystem_nodes_r.name AS node_name,
    array_view_pdev_r.subsys_id AS array_id,
    COALESCE(array_view_subsystem_r.name, array_view_subsystem_r.description) AS array_name,
    array_view_subsystem_r.vendor AS array_vendor,
    array_view_subsystem_r.product AS array_product,
    array_view_subsystem_r.raidgroup_capable,
    rb_rg_capable.display AS display_raidgroup_capable,
    COALESCE(faultobj.condition, 0) AS condition,
    rb_con.display AS display_condition,
    array_view_pdev_r.status,
    rb_state.display AS display_status,
    array_view_pdev_r.size,
    array_view_pdev_r.available AS available_size,
    COALESCE(array_view_pdev_r.size, 0::bigint) - COALESCE(array_view_pdev_r.available, 0::bigint) AS used_size,
        CASE
            WHEN array_view_pdev_r.size <= 0 THEN 0::numeric
            ELSE (COALESCE(array_view_pdev_r.size, 0::bigint) - COALESCE(array_view_pdev_r.available, 0::bigint))::numeric * 100.0 / COALESCE(array_view_pdev_r.size, 0::bigint)::numeric
        END AS pct_used,
    array_view_pdev_r.busno,
    array_view_pdev_r.slotno,
    array_view_pdev_r.rpm,
        CASE
            WHEN array_view_pdev_r.media_type IS NULL THEN 'HDD'::character varying
            ELSE array_view_pdev_r.media_type
        END AS media_type,
    array_view_pdev_r.vendor_media_type AS media_classification,
        CASE
            WHEN array_view_pdev_r.spare_size <> 0 THEN 1::boolean
            ELSE 0::boolean
        END AS is_spare,
    rb_is_spare.display AS display_is_spare,
    array_view_pdev_r.spare_size,
    array_view_pdev_r.is_virtual,
    rb_is_virtual.display AS display_is_virtual,
    array_view_ldev_r.id AS ext_ldev_id,
    COALESCE(array_view_ldev_r.name, array_view_pdev_map_r.producer_id) AS ext_ldev_name,
    array_view_ldev_r.subsys_id AS ext_array_id,
    ext_array.name AS ext_array_name,
    array_view_pdev_r.is_shared,
    rb_is_shared.display AS display_is_shared,
    array_view_pdev_r.type AS pdev_type,
    concat('^', array_view_pdev_r.name, '$^', rb_con.display, '$^', array_view_pdev_r.media_type, '$^', array_view_pdev_r.vendor_media_type, '$^', COALESCE(array_view_ldev_r.name, array_view_pdev_map_r.producer_id), '$') AS search_key,
    locale.id AS locale_id,
    array_view_pdev_r.vendor AS vendor,
	case when array_view_pdev_nodes_r.is_export=0 then 'Yes' else 'No' END as exported 
   FROM array_view_pdev_r
   JOIN array_view_subsystem_r ON array_view_pdev_r.subsys_id::text = array_view_subsystem_r.id::text
   LEFT JOIN array_view_pdev_nodes_r ON array_view_pdev_nodes_r.pdev_id::text = array_view_pdev_r.id::text
   LEFT JOIN array_view_subsystem_nodes_r ON array_view_pdev_nodes_r.node_id::text = array_view_subsystem_nodes_r.id::text
   LEFT JOIN array_view_pdev_map_r ON array_view_pdev_map_r.consumer_id::text = array_view_pdev_r.id::text AND array_view_pdev_map_r.consumer_type::text = 'PDEV'::text AND array_view_pdev_map_r.producer_type::text = 'EXTERNAL_LDEV'::text
   LEFT JOIN array_view_ldev_r ON array_view_pdev_map_r.producer_id::text = array_view_ldev_r.id::text AND array_view_pdev_map_r.producer_type::text = 'EXTERNAL_LDEV'::text
   LEFT JOIN array_view_subsystem_r ext_array ON array_view_ldev_r.subsys_id::text = ext_array.id::text
   JOIN ui_view_supp_locale_r locale ON locale.id IS NOT NULL
   LEFT JOIN ui_view_enum_def_r enum_state ON enum_state.object::text = 'PDEV'::text AND enum_state.property::text = 'STATE'::text AND enum_state.int_value = array_view_pdev_r.status
   LEFT JOIN ui_view_res_bundle_r rb_state ON enum_state.resource_id::text = rb_state.id::text AND locale.id::text = rb_state.locale_id::text
   LEFT JOIN fault_view_obj_condition faultobj ON faultobj.id::text = array_view_pdev_r.id::text AND faultobj.tbl_type::text = 'vrts_array_pdev'::text
   LEFT JOIN vom_view_enum_bundle rb_con ON rb_con.object::text = 'OBJECT'::text AND rb_con.property::text = 'CONDITION'::text AND rb_con.int_value = COALESCE(faultobj.condition, 0) AND locale.id::text = rb_con.locale_id::text
   LEFT JOIN vom_view_enum_bundle rb_is_shared ON rb_is_shared.object::text = 'OBJECT'::text AND rb_is_shared.property::text = 'PROPERTY'::text AND rb_is_shared.value::smallint = array_view_pdev_r.is_shared AND locale.id::text = rb_is_shared.locale_id::text
   LEFT JOIN vom_view_enum_bundle rb_is_spare ON rb_is_spare.object::text = 'OBJECT'::text AND rb_is_spare.property::text = 'PROPERTY'::text AND rb_is_spare.value::boolean =
CASE
WHEN array_view_pdev_r.spare_size <> 0 THEN 1::boolean
ELSE 0::boolean
END AND locale.id::text = rb_is_spare.locale_id::text
   LEFT JOIN vom_view_enum_bundle rb_is_virtual ON rb_is_virtual.object::text = 'OBJECT'::text AND rb_is_virtual.property::text = 'PROPERTY'::text AND rb_is_virtual.value::smallint = array_view_pdev_r.is_virtual AND locale.id::text = rb_is_virtual.locale_id::text
   LEFT JOIN vom_view_enum_bundle rb_rg_capable ON rb_rg_capable.object::text = 'OBJECT'::text AND rb_rg_capable.property::text = 'PROPERTY'::text AND rb_rg_capable.value::smallint = array_view_subsystem_r.raidgroup_capable AND locale.id::text = rb_rg_capable.locale_id::text
where array_view_pdev_r.is_shared=0;

grant SELECT on vom_view_storage_array_fss_pdev to HABGUEST;
grant DELETE,INSERT,UPDATE,SELECT on vom_view_storage_array_fss_pdev to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on vom_view_storage_array_fss_pdev to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on vom_view_storage_array_fss_pdev to HABDBSYNC;

/*
 * 4.VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM
 */
-- View: VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM

DROP VIEW if exists VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM;

CREATE OR REPLACE VIEW VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM AS 
 SELECT 
 	nas_fs.id,
    nas_fs.name,
    nas_fs.status,
    nas_fs.layout,
    nas_fs.file_storage_capacity,
    nas_fs.file_storage_used,
    nas_fs.file_storage_capacity - nas_fs.file_storage_used as file_storage_free,
    nas_fs.subsys_id as ARRAY_ID,
    nas_fs.subtype,
    dev_grp.ID as RG_ID,
    dev_grp.FREE_SIZE as POOL_SIZE,
    dev_grp.name as POOL_NAME,
    concat('^', nas_fs.name, '$^', nas_fs.status, '$^', nas_fs.layout, '$^', nas_fs.subtype, '$^') AS search_key
FROM ARRAY_VIEW_NAS_FILESYSTEM_R nas_fs
INNER JOIN ARRAY_VIEW_DEVICE_GROUP_R dev_grp ON nas_fs.DEVICE_GROUP_ID = dev_grp.ID
;

grant SELECT on VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM to HABGUEST;
grant DELETE,INSERT,UPDATE,SELECT on VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on VOM_VIEW_STORAGE_NAS_SNASFILESYSTEM to HABDBSYNC;


/*
 * 5. ARRAY_VIEW_USER_ACCOUNT_R
 */
-- View: ARRAY_VIEW_USER_ACCOUNT_R

-- DROP VIEW ARRAY_VIEW_USER_ACCOUNT_R;

create or replace view ARRAY_VIEW_USER_ACCOUNT_R AS
	select P_ARRAY_USER_ACCOUNT.ID,
		P_ARRAY_USER_ACCOUNT.SHARE_ID,
		P_ARRAY_USER_ACCOUNT.SUBSYS_ID,
		P_ARRAY_USER_ACCOUNT.NAME,
		P_ARRAY_USER_ACCOUNT.ACCESS_KEY,
		P_ARRAY_USER_ACCOUNT.SECRET_KEY,
		P_ARRAY_USER_ACCOUNT.TYPE
	from P_ARRAY_USER_ACCOUNT;
	
/*
 * 6. VOM_VIEW_STORAGE_S3_SHARE_ACCOUNT
 */
-- View: VOM_VIEW_STORAGE_S3_SHARE_ACCOUNT

-- DROP VIEW VOM_VIEW_STORAGE_S3_SHARE_ACCOUNT;

create or replace view VOM_VIEW_STORAGE_S3_SHARE_ACCOUNT AS
	select ARRAY_VIEW_USER_ACCOUNT_R.ID,
		ARRAY_VIEW_USER_ACCOUNT_R.SHARE_ID,
		ARRAY_VIEW_USER_ACCOUNT_R.NAME,
		ARRAY_VIEW_USER_ACCOUNT_R.ACCESS_KEY,
		ARRAY_VIEW_USER_ACCOUNT_R.SECRET_KEY
	from ARRAY_VIEW_USER_ACCOUNT_R
	where TYPE='S3';	

/*
 * 7.VOM_VIEW_STORAGE_NAS_SNAS_SHARE
 */
-- View: VOM_VIEW_STORAGE_NAS_SNAS_SHARE

drop view if exists VOM_VIEW_STORAGE_NAS_SNAS_SHARE;
CREATE or REPLACE VIEW VOM_VIEW_STORAGE_NAS_SNAS_SHARE AS
	with innertab as(select path ,count(distinct parent_type) cnt from ARRAY_VIEW_NAS_SHARE_R group by path)
	select 
		nas_share.ID,
	    nas_share.NAME AS NAME,
		nas_share.SUBSYS_ID AS ARRAY_ID,
		nas_share.MOUNT_POINT_TYPE AS SHARE_MOUNT_POINT_TYPE,
		nas_share.PARENT_TYPE,
		nas_share.PATH AS share_path,
		nas_share.STATUS,
		nas_fs.ID AS parent_id,
		nas_fs.name AS FS_NAME,
		share_consumer.cons_priviledge AS share_priviledge,		
		coalesce(nas_fs.ARRAY_ID,subsys.id) AS FS_SUBSYS_ID,
		case when innertab.cnt>1 then 'Yes' else 'No' END as MULTIPROTOCOL,
		concat('^', nas_share.name, '$^', nas_share.path, '$^', nas_share.parent_type, '$^', nas_share.status, '$^') AS search_key
	FROM ARRAY_VIEW_NAS_SHARE_R nas_share join innertab on innertab.path=nas_share.path
    LEFT OUTER JOIN VOM_VIEW_STORAGE_NAS_FILESYSTEM nas_fs ON nas_share.PARENT_ID = nas_fs.ID 
    LEFT OUTER JOIN ARRAY_VIEW_SUBSYSTEM_R subsys ON subsys.id = nas_share.subsys_id
    LEFT OUTER JOIN VOM_VIEW_STORAGE_SHARE_CONSUMER_HOST share_consumer ON share_consumer.share_id = nas_share.id
;
grant SELECT on VOM_VIEW_STORAGE_NAS_SNAS_SHARE to HABGUEST;
grant DELETE,INSERT,UPDATE,SELECT on VOM_VIEW_STORAGE_NAS_SNAS_SHARE to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on VOM_VIEW_STORAGE_NAS_SNAS_SHARE to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on VOM_VIEW_STORAGE_NAS_SNAS_SHARE to HABDBSYNC;

/*
 * 8.VOM_VIEW_STORAGE_NAS_SHARE_CONSUMER
 */
-- View: vom_view_storage_nas_share_consumer

DROP VIEW IF EXISTS vom_view_storage_nas_share_consumer;
CREATE OR REPLACE VIEW vom_view_storage_nas_share_consumer AS 
 SELECT nas_share.id AS share_id,
    nas_share.mount_point_type AS share_mount_point_type,
    consumer.privilege,
    consumer.host_name,
    consumer.host_id,
    concat('^', consumer.privilege, '$^', consumer.host_name, '$^', consumer.host_id, '$^') AS search_key
   FROM P_ARRAY_NAS_SHARE nas_share
   JOIN array_view_share_consumer_r consumer 
   ON id = share_id;

GRANT SELECT ON vom_view_storage_nas_share_consumer TO habguest;
GRANT DELETE,INSERT,UPDATE,SELECT ON vom_view_storage_nas_share_consumer TO habdbsync;
GRANT DELETE,INSERT,UPDATE,SELECT ON vom_view_storage_nas_share_consumer TO habgui;
GRANT DELETE,INSERT,UPDATE,SELECT ON vom_view_storage_nas_share_consumer TO habadm;

/*==============================================================*/
/* Add fs operation permission                                */
/*==============================================================*/
insert into P_OPER_ROLE_DEF values('delete_fs', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Destroy file system');
insert into P_OPER_ROLE_DEF values('fs_create_simple', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create file system');
insert into P_OPER_ROLE_DEF values('fs_create_mirrored', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create file system');
insert into P_OPER_ROLE_DEF values('fs_create_mirrored_stripe', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create file system');
insert into P_OPER_ROLE_DEF values('fs_create_striped', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create file system');
insert into P_OPER_ROLE_DEF values('fs_create_striped_mirror', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create file system');
insert into P_OPER_ROLE_DEF values('fs_create_fss', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create file system');
insert into P_OPER_ROLE_DEF values('grow_fs', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Grow file system');
insert into P_OPER_ROLE_DEF values('shrink_fs', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Shrink file system');
insert into P_OPER_ROLE_DEF values('fs_create_snapshot', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Create Snapshot');
insert into P_OPER_ROLE_DEF values('fs_delete_snapshot', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Delete Snapshot');
insert into P_OPER_ROLE_DEF values('fs_make_snapshot_online', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Make Snapshot Online');
insert into P_OPER_ROLE_DEF values('fs_take_snapshot_offline', 'vrts_ddl_enclosure', 'STORAGE', 2, 'Take Snapshot Offline');

/*==============================================================
 * 
 * 
 * SNAS Fault and risk definitions                              
 *==============================================================*/

/* FS consumption */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_nasfilesystem','NAS_FS_CONS_RISK_THRESHOLD',1,1,1,NULL,'I','event.alert.vom.array.nasfs.consumption.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','NAS_FS_CONS_RISK_THRESHOLD',1,0,1,NULL,'I','event.alert.vom.array.nasfs.consumption.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','NAS_FS_CONS_RISK_THRESHOLD',1,0,1,NULL,'I','event.alert.vom.array.nasfs.consumption.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('NAS_FS_CONS_RISK_THRESHOLD');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('NAS_FS_CONS_RISK_THRESHOLD','en_US','NAS FileSystem over consumption risk');


INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_nasfilesystem','NAS_FS_DISABLED',1,1,1,NULL,'I','event.alert.vom.array.nasfs.fsdisabled.risk');
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','NAS_FS_DISABLED',1,0,1,NULL,'I','event.alert.vom.array.nasfs.fsdisabled.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('NAS_FS_DISABLED');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('NAS_FS_DISABLED','en_US','NAS fileSystem is disabled');


INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_storagepool','ALL_SNAS_POOL_DISABLED',1,1,1,NULL,'I','event.alert.vom.array.nasfs.storage_pool_disabled.risk');
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','ALL_SNAS_POOL_DISABLED',1,0,1,NULL,'I','event.alert.vom.array.nasfs.storage_pool_disabled.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('ALL_SNAS_POOL_DISABLED');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('ALL_SNAS_POOL_DISABLED','en_US','All pools are disabled.');


/* FS inode usage */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_enclosure_node','NAS_FS_INODE_USAGE_RISK_THRESHOLD',1,1,1,NULL,'I','event.alert.vom.array.nasfs.inode_usage.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','NAS_FS_CONS_INODE_USAGE_THRESHOLD',1,0,1,NULL,'I','event.alert.vom.array.nasfs.inode_usage.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','NAS_FS_INODE_USAGE_RISK_THRESHOLD',1,0,1,NULL,'I','event.alert.vom.array.nasfs.inode_usage.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('NAS_FS_INODE_USAGE_RISK_THRESHOLD');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('NAS_FS_INODE_USAGE_RISK_THRESHOLD','en_US','NAS FileSystem high inode usage risk');


/* PDEV fault */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_pdev','NAS_PDEV_FAILING_RISK',1,1,1,NULL,'I','event.alert.vom.array.nasfs.disk_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','NAS_PDEV_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.disk_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','NAS_PDEV_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.disk_failing.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('NAS_PDEV_FAILING_RISK');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('NAS_PDEV_FAILING_RISK','en_US','NAS disk failure risk');


/* NODE fault */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_enclosure_node','NAS_NODE_FAILING_RISK',1,1,1,NULL,'I','event.alert.vom.array.nasfs.node_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','NAS_NODE_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.node_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','NAS_NODE_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.node_failing.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('NAS_NODE_FAILING_RISK');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('NAS_NODE_FAILING_RISK','en_US','NAS node failure risk');



/* Storage Pool fault */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_storagepool','NAS_STORAGEPOOL_FAILING_RISK',1,1,1,NULL,'I','event.alert.vom.array.nasfs.storage_pool_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','NAS_STORAGEPOOL_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.storage_pool_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','NAS_STORAGEPOOL_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.storage_pool_failing.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('NAS_STORAGEPOOL_FAILING_RISK');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('NAS_STORAGEPOOL_FAILING_RISK','en_US','NAS node failure risk');


/* NFS server down fault */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_enclosure_node','NFS_SERVER_FAILING_RISK',1,1,1,NULL,'I','event.alert.vom.array.nasfs.nfs_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','NFS_SERVER_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.nfs_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','NFS_SERVER_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.nfs_failing.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('NFS_SERVER_FAILING_RISK');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('NFS_SERVER_FAILING_RISK','en_US','NFS server offline risk');


/* CIFS server down fault */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_enclosure_node','CIFS_SERVER_FAILING_RISK',1,1,1,NULL,'I','event.alert.vom.array.cifs.nfs_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','CIFS_SERVER_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.cifs_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','CIFS_SERVER_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.cifs_failing.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('CIFS_SERVER_FAILING_RISK');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('CIFS_SERVER_FAILING_RISK','en_US','CIFS server offline risk');

/* FTP server down fault */
INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_array_enclosure_node','FTP_SERVER_FAILING_RISK',1,1,1,NULL,'I','event.alert.vom.array.cifs.ftp_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_ddl_enclosure','FTP_SERVER_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.ftp_failing.risk');

INSERT INTO HABDBSYNC.P_FAULT_DEFINITION (OBJ_TYPE,FID,TYPE,BASE,SYS_DEFINED_CONDITION,USER_DEFINED_CONDITION,SCOPE,ALERT_TOPIC)
VALUES('vrts_appl_grp','FTP_SERVER_FAILING_RISK',1,0,1,NULL,'I','event.alert.vom.array.nasfs.ftp_failing.risk');

INSERT INTO HABDBSYNC.P_UI_RESOURCE (ID) VALUES('FTP_SERVER_FAILING_RISK');
INSERT INTO HABDBSYNC.P_UI_RES_BUNDLE (ID,LOCALE_ID,DISPLAY) VALUES('FTP_SERVER_FAILING_RISK','en_US','FTP server offline risk');



/*===============================================================*/
/* VIEW: VOM_VIEW_STORAGE_FS_SNAPSHOT  */
/*===============================================================*/
DROP VIEW if exists vom_view_storage_fs_snapshot;

CREATE OR REPLACE VIEW vom_view_storage_fs_snapshot AS 
 SELECT p_array_nas_fs_snapshot.id,
    p_array_nas_fs_snapshot.subsys_id,
    p_array_nas_fs_snapshot.fs_id,
    p_array_nas_fs_snapshot.name,
    p_array_nas_fs_snapshot.status,
    p_array_nas_fs_snapshot.ctime,
    p_array_nas_fs_snapshot.size,
    concat('^', p_array_nas_fs_snapshot.subsys_id, '$^', p_array_nas_fs_snapshot.fs_id, '$^', p_array_nas_fs_snapshot.name, '$^', p_array_nas_fs_snapshot.status, '$^', p_array_nas_fs_snapshot.ctime, '$^', p_array_nas_fs_snapshot.size, '$^') AS search_key
   FROM p_array_nas_fs_snapshot;

ALTER TABLE vom_view_storage_fs_snapshot
  OWNER TO habdbsync;
GRANT ALL ON TABLE vom_view_storage_fs_snapshot TO habdbsync;
GRANT SELECT ON TABLE vom_view_storage_fs_snapshot TO habguest;


/*===============================================================*/
/* VIEW: ARRAY_VIEW_SUBSYSTEM_NODES_STATUS  */
/*===============================================================*/
drop view if exists array_view_subsystem_nodes_status;
create or replace view array_view_subsystem_nodes_status AS
select
	clusternode.name,
	clusternode.state,
	clusternode.id,
	clusternode.subsys_id,
	diskToNodeMap.value as os_version,
    concat('^', clusternode.name, '$^', clusternode.state, '$^', disktonodemap.value, '$^') AS search_key
from array_view_subsystem_nodes_r as clusternode
join array_view_subsystem_nodes_prop_r as diskToNodeMap on diskToNodeMap.node_id = clusternode.id and diskToNodeMap.key = 'os_version';
grant SELECT on array_view_subsystem_nodes_status to HABGUEST;
grant DELETE,INSERT,UPDATE,SELECT on array_view_subsystem_nodes_status to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on array_view_subsystem_nodes_status to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on array_view_subsystem_nodes_status to HABDBSYNC;

/*===============================================================*/
/* VIEW: ARRAY_VIEW_NODE_INTF_ADDR_R                             */
/*===============================================================*/
drop view if exists array_view_node_intf_addr_r;
create or replace view array_view_node_intf_addr_r as
select
    P_ARRAY_NODE_INTF_ADDR.IP,
    P_ARRAY_NODE_INTF_ADDR.NETMASK,
    P_ARRAY_NODE_INTF_ADDR.NODE_ID,
    P_ARRAY_NODE_INTF_ADDR.DEV_NAME,
    P_ARRAY_NODE_INTF_ADDR.TYPE,
    P_ARRAY_NODE_INTF_ADDR.STATUS,
    P_ARRAY_NODE_INTF_ADDR.TAG,
    concat('^', p_array_node_intf_addr.ip, '$^', p_array_node_intf_addr.dev_name, '$^', p_array_node_intf_addr.status, '$^', p_array_node_intf_addr.type, '$^', p_array_node_intf_addr.tag, '$^') AS search_key
from
    P_ARRAY_NODE_INTF_ADDR;
grant SELECT on array_view_node_intf_addr_r to HABGUEST;
grant DELETE,INSERT,UPDATE,SELECT on array_view_node_intf_addr_r to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on array_view_node_intf_addr_r to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on array_view_node_intf_addr_r to HABDBSYNC;
/*===============================================================*/
/* VIEW: VOM_VIEW_CLUSTERNODE_LOCALDISK                          */
/*===============================================================*/
drop view if exists vom_view_clusternode_localdisk;
CREATE OR REPLACE VIEW vom_view_clusternode_localdisk AS
SELECT
	snasDisk.id,
	clusternode.id as node_id,
	snasDisk.name,
	diskToNodeMap.status as disk_status,
	snasDisk.size,
	snasDisk.available,
	(case when snasDisk.is_shared = 0 then 'No'
	when snasDisk.is_shared = 1 then 'Yes' 
	else 'Unknown' end) as is_shared,
   concat('^', snasdisk.name, '$^', disktonodemap.status, '$^') AS search_key
 from array_view_subsystem_nodes_r as clusternode
 join array_view_pdev_nodes_r as diskToNodeMap on diskToNodeMap.node_id=  clusternode.id
 join array_view_pdev_r as snasDisk on snasDisk.id = diskToNodeMap.pdev_id;
 grant SELECT on vom_view_clusternode_localdisk to HABGUEST;
 grant DELETE,INSERT,UPDATE,SELECT on vom_view_clusternode_localdisk to HABGUI;
 grant DELETE,INSERT,UPDATE,SELECT on vom_view_clusternode_localdisk to HABADM;
 grant DELETE,INSERT,UPDATE,SELECT on vom_view_clusternode_localdisk to HABDBSYNC;
/*===============================================================*/
/* VIEW: VOM_VIEW_DISK_POOL_TREE                                 */
/*===============================================================*/
drop view if exists vom_view_disk_pool_tree;
CREATE OR REPLACE VIEW vom_view_disk_pool_tree AS
select
d.name as disk,
d.available as dsize,
p.name as pool,
p.free_size ,
p.subsys_id,
p.layout,
p.id
from (P_ARRAY_PDEV as d inner join P_ARRAY_DEVICEGROUP_MAP as m on d.id=m.device_id )
inner join P_ARRAY_DEVICE_GROUP as p on p.id=m.device_group_id;
grant SELECT on vom_view_disk_pool_tree to HABGUEST;
grant DELETE,INSERT,UPDATE,SELECT on vom_view_disk_pool_tree to HABGUI;
grant DELETE,INSERT,UPDATE,SELECT on vom_view_disk_pool_tree to HABADM;
grant DELETE,INSERT,UPDATE,SELECT on vom_view_disk_pool_tree to HABDBSYNC;
/*==============================================================*/
/* DB changes for new perspective                               */
/*==============================================================*/

--insert into P_PERSPECTIVE values('TENANT', 'Tenant');
--
--insert into P_SF_GENERIC_VIEW_GROUP(grp_id, type, grp_name, description, shared, consistent, sub_type) values('985b0611-2890-4ecc-8db1-2b48611b520e', 'APPLICATION', 'DEFAULT@TENANT', '', 1, 0, 'ORGANIZATION');
--
--insert into P_SF_OE_PERSPECTIVE_REL values('985b0611-2890-4ecc-8db1-2b48611b520e', 'TENANT');
--
--insert into P_SF_GENERIC_VIEW_GROUP_REL values('985b0611-2890-4ecc-8db1-2b48611b520e', '985b0611-2890-4ecc-8db1-2b48611b520e');
--
--insert into P_SECURITY_GROUP_REL values(1, '985b0611-2890-4ecc-8db1-2b48611b520e', 2, 'TENANT');
--
--
---- Function: sp_update_task_perspectives()
--
---- DROP FUNCTION sp_update_task_perspectives();
--
--CREATE OR REPLACE FUNCTION sp_update_task_perspectives()
--  RETURNS void AS
--$BODY$
--
--     DECLARE         name               varchar(256);
--     DECLARE         sstate             varchar(5);
--     DECLARE         serror             text;
--
--begin
--
--     drop table if exists task_perspective_count;
--     create TEMPORARY TABLE task_perspective_count
--     (
--       id            varchar(38)                not null,
--       count         int                        default 0,
--       constraint PK_task_perspective_count primary key (id)
--     );
--     
--     PERFORM UPSERTRULE('task_perspective_count');
--
--     -- first for each task get the count of perspective it belongs to based on name
--     insert into task_perspective_count(id, count)
--     select task.id, count(distinct oper.perspective_type)
--         from P_OPER_ROLE_DEF oper
--         inner join p_sf_task task on oper.DISPLAY_NAME = task.name
--     group by task.id;
--
--     --      use query without object types to update tasks belonging to just one perspective
--     -- OR use query with object types to update tasks belonging to multiple perspectives
--     insert into p_sf_task(id, perspectives) 
--     select v.id,  sum(coalesce(v.perspective_type, 0))
--     from (SELECT distinct task.ID,
--                  case when oper.perspective_type  = 'SYSTEM'         then ( 1::integer)
--                       when oper.perspective_type  = 'STORAGE'        then ( 2::integer)
--                       when oper.perspective_type  = 'AVAILABILITY'   then ( 4::integer)
--                       when oper.perspective_type  = 'VIRTUALIZATION' then ( 8::integer)
--                       when oper.perspective_type  = 'INFRA'          then (16::integer)
--                       when oper.perspective_type  = 'TENANT'         then (32::integer)
--                  else                                                     ( 0::integer)
--                  end as perspective_type
--           FROM SF_VIEW_TASK_R task
--                inner join P_OPER_ROLE_DEF oper on TASK.NAME=OPER.DISPLAY_NAME
--                inner join task_perspective_count cnt on task.id = cnt.id
--           where (cnt.count = 1) or
--                 (cnt.count > 1 and oper.object_type in ('', task.source_type, task.target_type))
--             ) v
--      group by v.id;
--
--EXCEPTION
--
--   WHEN OTHERS THEN
--       SELECT SQLSTATE, SQLERRM INTO sstate, serror;
--       IF ( sstate != '00000' )
--       THEN
--           raise log  '% Error failed at = %, serror() = %, sstate() = %', now(), 'SP_UPDATE_TASK_PERSPECTIVES:', serror, sstate;
--       END IF;
--
--end;
--$BODY$
--  LANGUAGE plpgsql VOLATILE
--  COST 100;
--ALTER FUNCTION sp_update_task_perspectives()
--  OWNER TO habdbsync;
--
---- Function: fn_get_task_perspectives(text, character varying, character varying)
--
---- DROP FUNCTION fn_get_task_perspectives(text, character varying, character varying);
--
--CREATE OR REPLACE FUNCTION fn_get_task_perspectives(
--    task_name text,
--    source_type character varying,
--    target_type character varying)
--  RETURNS integer AS
--$BODY$
--
--     DECLARE         sstate             varchar(5);
--     DECLARE         serror             text;
--     DECLARE         name               varchar(256);
--     DECLARE         value              int;
--     DECLARE         count              int;
--
--begin
--
--     select count(distinct oper.perspective_type) into count
--     from P_OPER_ROLE_DEF oper
--     where oper.DISPLAY_NAME = task_name;
--
--     if (count > 1)
--     then
--         SELECT sum(distinct case when oper.perspective_type  = 'SYSTEM'         then  1::integer
--                                  when oper.perspective_type  = 'STORAGE'        then  2::integer
--                                  when oper.perspective_type  = 'AVAILABILITY'   then  4::integer
--                                  when oper.perspective_type  = 'VIRTUALIZATION' then  8::integer
--                                  when oper.perspective_type  = 'INFRA'          then 16::integer
--                                  when oper.perspective_type  = 'TENANT'         then 32::integer
--                                  else                                                 0::integer
--                         end) into value
--        FROM P_OPER_ROLE_DEF oper
--        where oper.DISPLAY_NAME = task_name and oper.OBJECT_TYPE in ( '', source_type, target_type );
--     else
--         SELECT sum(distinct case when oper.perspective_type  = 'SYSTEM'         then  1::integer
--                                  when oper.perspective_type  = 'STORAGE'        then  2::integer
--                                  when oper.perspective_type  = 'AVAILABILITY'   then  4::integer
--                                  when oper.perspective_type  = 'VIRTUALIZATION' then  8::integer
--                                  when oper.perspective_type  = 'INFRA'          then 16::integer
--                                  when oper.perspective_type  = 'TENANT'         then 32::integer
--                                  else                                                 0::integer
--                             end) into value
--         FROM P_OPER_ROLE_DEF oper 
--         where OPER.DISPLAY_NAME = task_name;
--     end if;
--
--     return coalesce(value,0);
--
--EXCEPTION
--
--   WHEN OTHERS THEN
--       SELECT SQLSTATE, SQLERRM INTO sstate, serror;
--       IF ( sstate != '00000' )
--       THEN
--           raise log  '% Error failed at = %, serror() = %, sstate() = %', now(), 'FN_GET_TASK_PERSPECTIVES:', serror, sstate;
--       END IF;
--
--end;
--$BODY$
--  LANGUAGE plpgsql VOLATILE
--  COST 100;
--ALTER FUNCTION fn_get_task_perspectives(text, character varying, character varying)
--  OWNER TO habdbsync;
--
--
--update P_OPER_ROLE_DEF set object_type='vrts_ddl_enclosure', perspective_type='TENANT' where name='create_share';	
--
---- Function: sp_get_task_with_uglist(character varying, character varying, character varying, character varying)
--
---- DROP FUNCTION sp_get_task_with_uglist(character varying, character varying, character varying, character varying);
--
--CREATE OR REPLACE FUNCTION sp_get_task_with_uglist(
--    IN perspective_type character varying,
--    IN top_level_oe character varying,
--    IN ug_id_list character varying,
--    IN role_id_list character varying DEFAULT '2,3,4'::character varying)
--  RETURNS TABLE(default_name character varying, display_state character varying, end_time timestamp without time zone, id character varying, error bigint, is_parent smallint, level integer, locale_id character varying, name character varying, parent_tskid character varying, search_key text, source character varying, source_id character varying, source_type character varying, start_time timestamp without time zone, state character varying, target text, target_id character varying, target_type character varying, user_name character varying) AS
--$BODY$
--
--
--    DECLARE OE_LIST text;
--    DECLARE serror  text;
--    DECLARE sstate  varchar(5);
--
--begin
--     select string_agg(object_id::text, ',') into OE_LIST
--     from (select distinct grp_id as object_id, 'vrts_appl_grp_oe' as object_type
--           from SP_GET_OE_ROLE(perspective_type, TOP_LEVEL_OE, UG_ID_LIST, 1)
--           union
--           select gvg.grp_id, 'vrts_appl_grp_oe'
--           from  p_sf_generic_view_group gvg
--                 inner join p_sf_oe_perspective_rel opr on gvg.grp_id = opr.grp_id and
--                                                                     opr.perspective_id = perspective_type and 
--                                                                     gvg.grp_name = 'DEFAULT@' || perspective_type
--                 inner join p_security_group_rel sgr on sgr.role_id::text in (select row_value from sa_split_list(ROLE_ID_LIST, ','))
--           where TOP_LEVEL_OE is null) v;
--
--     return query
--with tmp_view(default_name, display_state,end_time,id,error,is_parent,level,locale_id,name,parent_tskid,search_key,source,source_id,source_type,start_time,state
--             ,target,target_id,target_type,user_name) as
--             (select
--                tasks.DEFAULT_NAME,
--                tasks.DISPLAY_STATE,
--                tasks.END_TIME,
--                tasks.ID,
--                tasks.ERROR,
--                tasks.IS_PARENT,
--                tasks.LEVEL,
--                tasks.LOCALE_ID,
--                tasks.NAME,
--                tasks.PARENT_TSKID,
--                tasks.SEARCH_KEY,
--                tasks.SOURCE,
--                tasks.SOURCE_ID,
--                tasks.SOURCE_TYPE,
--                tasks.START_TIME,
--                tasks.STATE,
--                tasks.TARGET,
--                tasks.TARGET_ID,
--                tasks.TARGET_TYPE,
--                tasks.USER_NAME
--                from  SP_GET_TASK_WITH_PERSPECTIVE(perspective_type) tasks),
--     tmp_oe(object_id, object_type) as
--     (select distinct oe_id as object_id, 'vrts_appl_grp_oe'::varchar as object_type
--      from SP_GET_OE_ROLE_ID_USING_UGLIST(perspective_type, OE_LIST, UG_ID_LIST)
--      where role_id::text in (select row_value from sa_split_list(ROLE_ID_LIST, ',')) and
--            security_group_id::text in (select row_value from sa_split_list(UG_ID_LIST, ','))
--     ),
--     tmp_view_availability(default_name, display_state,end_time,id,error,is_parent,level,locale_id,name,parent_tskid,search_key,source,source_id,source_type,start_time,state
--             ,target,target_id,target_type,user_name) as
--              (select tmp_view.*
--               from tmp_view
--                    inner join (select v.object_id, 'vrts_cluster'::text as object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_cluster', 1) v
--                                union all
--                                select hc.host_id as object_id, 'vrts_host'::text as object_type
--                                from SF_VIEW_HOST_TO_HC HC
--                                     inner join SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_cluster', 1) CLUS on HC.HC_ID = CLUS.OBJECT_ID and CLUS.OBJECT_TYPE = 'vrts_cluster'
--                                where HC.HC_TYPE IN ('CLUSTER','METACLUSTER')
--                                union all
--                                select tmp_oe.object_id, tmp_oe.object_type from tmp_oe
--                                ) obj
--                                ON perspective_type = 'AVAILABILITY' and tmp_view.source_ID = obj.object_ID and tmp_view.source_TYPE = obj.object_type
--               union 
--               select tmp_view.*
--               from tmp_view
--                    inner join (select v.rplan_id as object_id, 'vrts_rplan'::text as object_type from SP_GET_ACCESSIBLE_RCPLN(UG_ID_LIST) v where v.authorized = 1) obj
--                                ON perspective_type = 'AVAILABILITY' and tmp_view.target_ID = obj.object_ID and tmp_view.target_TYPE = obj.object_type
--               where TOP_LEVEL_OE is null
--
--             ),
--     tmp_view_system(default_name, display_state,end_time,id,error,is_parent,level,locale_id,name,parent_tskid,search_key,source,source_id,source_type,start_time,state
--             ,target,target_id,target_type,user_name) as
--             (select tmp_view.*
--              from tmp_view
--                inner join (select tmp_oe.object_id, tmp_oe.object_type from tmp_oe
--                            union all
--                            select v.object_id, v.object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_host', 1) v) obj
--                            ON perspective_type = 'SYSTEM' and tmp_view.source_ID = obj.object_ID and tmp_view.source_TYPE = obj.object_type),
--     tmp_view_storage(default_name, display_state,end_time,id,error,is_parent,level,locale_id,name,parent_tskid,search_key,source,source_id,source_type,start_time,state
--             ,target,target_id,target_type,user_name) as
--             (select tmp_view.*
--              from tmp_view
--                INNER JOIN (select tmp_oe.object_id, tmp_oe.object_type from tmp_oe
--                            union all
--                            select v.object_id, v.object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_ddl_enclosure', 1) v) obj
--                            ON perspective_type = 'STORAGE' and tmp_view.source_ID = obj.object_ID and tmp_view.source_TYPE = obj.object_type),
--     tmp_view_virt(default_name, display_state,end_time,id,error,is_parent,level,locale_id,name,parent_tskid,search_key,source,source_id,source_type,start_time,state
--             ,target,target_id,target_type,user_name) as
--             (select tmp_view.*
--              from tmp_view
--                   INNER JOIN (select tmp_oe.object_id, tmp_oe.object_type from tmp_oe
--                               union all
--                               select v.object_id, v.object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_host_vserver', 1) v) obj
--                               ON perspective_type = 'VIRTUALIZATION' and tmp_view.source_ID = obj.object_ID and tmp_view.source_TYPE = obj.object_type
--              union
--              select tmp_view.*
--              from tmp_view
--                   INNER JOIN ( select hcm.id as object_id, 'vrts_host_vcenter'::text as object_type
--                               from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_host_vserver', 1) hc
--                                    inner join p_host_config_mapping hcm on hc.object_id = hcm.object_id
--                              ) obj
--                            ON perspective_type = 'VIRTUALIZATION' and tmp_view.target_ID = obj.object_ID and tmp_view.target_TYPE = obj.object_type
--             union
--	     select tmp_view.*
--             from tmp_view
--                   INNER JOIN (select v.object_id, v.object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_host_vserver', 1) v
--			                   union all
--                               select p_host_config.id as object_id, 'vrts_host_vserver'::text as object_type from p_host_config where type = 'CH') obj
--                               ON perspective_type = 'VIRTUALIZATION' and tmp_view.source_ID = obj.object_ID and tmp_view.source_TYPE = obj.object_type
--             ),
--     tmp_view_infra(default_name, display_state,end_time,id,error,is_parent,level,locale_id,name,parent_tskid,search_key,source,source_id,source_type,start_time,state
--             ,target,target_id,target_type,user_name) as
--             (select distinct tmp_view.*
--              from tmp_view
--                INNER JOIN (select tmp_oe.object_id, tmp_oe.object_type from tmp_oe
--                            union all
--                            select v1.object_id, v1.object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_host', 1) v1
--                            union all
--                            select v2.object_id, v2.object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_ddl_enclosure', 1) v2) obj
--                            ON perspective_type = 'INFRA' and tmp_view.source_ID = obj.object_ID and tmp_view.source_TYPE = obj.object_type),
--     tmp_view_tenant(default_name, display_state,end_time,id,error,is_parent,level,locale_id,name,parent_tskid,search_key,source,source_id,source_type,start_time,state
--             ,target,target_id,target_type,user_name) as
--             (select tmp_view.*
--              from tmp_view
--                INNER JOIN (select tmp_oe.object_id, tmp_oe.object_type from tmp_oe
--                            union all
--                            select v.object_id, v.object_type from SP_Get_PBO_UGlist(perspective_type, UG_ID_LIST, 'vrts_ddl_enclosure', 1) v) obj
--                            ON perspective_type = 'TENANT' and tmp_view.source_ID = obj.object_ID and tmp_view.source_TYPE = obj.object_type)
--
--     select 
--            v.DEFAULT_NAME::varchar,
--            v.DISPLAY_STATE::varchar,
--            v.END_TIME::timestamp,
--            v.ID::varchar,
--            v.ERROR::bigint,
--            v.IS_PARENT::smallint,
--            v.LEVEL::integer,
--            v.LOCALE_ID::varchar,
--            v.NAME::varchar,
--            v.PARENT_TSKID::varchar,
--            v.SEARCH_KEY::text,
--            v.SOURCE::varchar,
--            v.SOURCE_ID::varchar,
--            v.SOURCE_TYPE::varchar,
--            v.START_TIME::timestamp,
--            v.STATE::varchar,
--            v.TARGET::text,
--            v.TARGET_ID::varchar,
--            v.TARGET_TYPE::varchar,
--            v.USER_NAME::varchar
--     from (
--         select v1.* from tmp_view_availability v1
--         union all
--         select v2.* from tmp_view_system v2
--         union all
--         select v3.* from tmp_view_storage v3
--         union all
--         select v4.* from tmp_view_infra v4
--         union all
--         select v5.* from tmp_view_virt v5
--         union all
--         select v6.* from tmp_view_tenant v6
--         ) v
--     ORDER BY v.start_time asc;
--
--EXCEPTION
--   WHEN OTHERS THEN
--       SELECT SQLSTATE, SQLERRM INTO sstate, serror;
--       IF ( sstate != '00000' )
--       THEN
--           raise log  '% Error failed at = %, serror() = %, sstate() = %', now(), 'SP_GET_TASK_WITH_UGLIST:', serror, sstate;
--       END IF;
--
--end;
--$BODY$
--  LANGUAGE plpgsql VOLATILE
--  COST 100
--  ROWS 1000;
--ALTER FUNCTION sp_get_task_with_uglist(character varying, character varying, character varying, character varying)
--  OWNER TO habdbsync;
--
--
---- Function: sp_get_task_with_perspective(character varying)
--
---- DROP FUNCTION sp_get_task_with_perspective(character varying);
--
--CREATE OR REPLACE FUNCTION sp_get_task_with_perspective(IN perspective_type character varying)
--  RETURNS TABLE(id character varying, name text, default_name text, exit_status character varying, state character varying, display_state character varying, target text, target_id character varying, target_type character varying, source character varying, source_id character varying, source_type character varying, user_name text, start_time timestamp without time zone, end_time timestamp without time zone, command text, output text, output_mime character varying, display_exit_status character varying, error bigint, thread character varying, level integer, parent_list text, is_parent smallint, parent_tskid character varying, access_uri character varying, perspectives integer, search_key text, locale_id character varying) AS
--$BODY$ 
--
-- DECLARE hmask int;
--
--begin
-- 
--     hmask =     case when perspective_type  = 'SYSTEM'         then  (1::integer)
--                      when perspective_type  = 'STORAGE'        then  (2::integer)
--                      when perspective_type  = 'AVAILABILITY'   then  (4::integer)
--                      when perspective_type  = 'VIRTUALIZATION' then  (8::integer)
--                      when perspective_type  = 'INFRA'          then   (16::integer)
--                      when perspective_type  = 'TENANT'         then   (32::integer)
--                 end ;
--
--     RETURN QUERY 
--     select utask.id,
--	    utask.name,
--	    utask.DEFAULT_NAME,
--	    utask.EXIT_STATUS,
--            utask.state,
--	    utask.DISPLAY_STATE, 
--	    utask.TARGET, 
--	    utask.TARGET_ID, 
--	    utask.TARGET_TYPE,
--	    utask.SOURCE,
--	    utask.SOURCE_ID,
--	    utask.SOURCE_TYPE,
--	    utask.USER_NAME,
--	    utask.START_TIME,
--	    utask.END_TIME,
--	    utask.COMMAND,
--	    utask.OUTPUT,
--	    utask.OUTPUT_MIME,
--	    utask.DISPLAY_EXIT_STATUS,
--	    utask.ERROR,
--	    utask.THREAD,
--            utask.LEVEL,
--	    utask.PARENT_LIST,
--	    utask.IS_PARENT,
--	    utask.PARENT_TSKID,
--	    utask.ACCESS_URI,
--	    utask.PERSPECTIVES,
--	    utask.SEARCH_KEY,
--	    utask.LOCALE_ID
--     from SF_VIEW_UI_TASK utask
--     where utask.parent_tskid is null and utask.perspectives & hmask = hmask;
--
--end;
--$BODY$
--  LANGUAGE plpgsql VOLATILE
--  COST 100
--  ROWS 1000;
--ALTER FUNCTION sp_get_task_with_perspective(character varying)
--  OWNER TO habdbsync;
--  
--  
---- View: vom_view_domain_security_group_authz
--
---- DROP VIEW vom_view_domain_security_group_authz;
--
--CREATE OR REPLACE VIEW vom_view_domain_security_group_authz AS 
-- SELECT vom_view_oe_security_group_authz.security_group_id,
--    vom_view_oe_security_group_authz.security_group_name,
--    vom_view_oe_security_group_authz.security_group_fqname,
--    vom_view_oe_security_group_authz.broker_id,
--    vom_view_oe_security_group_authz.domain_name,
--    vom_view_oe_security_group_authz.domain_type,
--    vom_view_oe_security_group_authz.broker_name,
--    vom_view_oe_security_group_authz.broker_type,
--    vom_view_oe_security_group_authz.broker_port,
--    vom_view_oe_security_group_authz.oe_id,
--    vom_view_oe_security_group_authz.oe_name,
--    vom_view_oe_security_group_authz.display_oe_name,
--    vom_view_oe_security_group_authz.object_type,
--    vom_view_oe_security_group_authz.display_object_type,
--    vom_view_oe_security_group_authz.role_id,
--    vom_view_oe_security_group_authz.role_name,
--    vom_view_oe_security_group_authz.perspective_id,
--    vom_view_oe_security_group_authz.perspective_name,
--    vom_view_oe_security_group_authz.locale_id
--   FROM vom_view_oe_security_group_authz
--  WHERE vom_view_oe_security_group_authz.oe_name::text = ANY (ARRAY['DEFAULT@INFRA'::character varying::text, 'DEFAULT@SYSTEM'::character varying::text, 'DEFAULT@STORAGE'::character varying::text, 'DEFAULT@AVAILABILITY'::character varying::text, 'DEFAULT@VIRTUALIZATION'::character varying::text, 'DEFAULT@TENANT'::character varying::text]);
--
--ALTER TABLE vom_view_domain_security_group_authz
--  OWNER TO habdbsync;
--GRANT ALL ON TABLE vom_view_domain_security_group_authz TO habdbsync;
--GRANT ALL ON TABLE vom_view_domain_security_group_authz TO habgui;
--GRANT SELECT ON TABLE vom_view_domain_security_group_authz TO habguest;
--
