#!/opt/VRTSsfmh/bin/perl

# $Id: isa_sec_mgmt.pl, 2016/04/13 22:12:09, Bhushan.Karayilthekkoot $
#
# $Copyright: Copyright (c) 2016 Veritas Technologies LLC.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# VERITAS TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
#
# The  Licensed  Software  and  Documentation  are  deemed  to be commercial
# computer  software  as  defined  in  FAR  12.212 and subject to restricted
# rights  as  defined in FAR Section 52.227-19 "Commercial Computer Software
# - Restricted  Rights"  and  DFARS 227.7202,  et seq.  "Commercial Computer
# Software  and  Commercial Computer Software Documentation," as applicable,
# and any successor regulations, whether delivered by Veritas as on premises
# or  hosted  services.  Any  use,  modification,  reproduction  release,
# performance,  display  or  disclosure  of  the  Licensed  Software  and
# Documentation by the U.S. Government shall be solely in accordance with
# the terms of this Agreement. $
#

#
# This script calls clish and returns value depending upon SUCCESS (0)
# or ERROR (1)
#

#!/opt/VRTSsfmh/bin/perl

BEGIN { unshift(@INC, "/opt/VRTSsfmh/lib/modules"); }

require Exporter;
require VRTS::Paths;
require VRTS::Util;
require VRTS::Agent;
require VRTS::Util;
require VRTS::EXITCODE;
require VRTS::Paths;
require VRTS::Logger;
require VRTS::OS;
require File::Path;
require VRTS::Config;
require VRTS::Task;

my $cmd_prefix = 'export NAS_OUTPUT=json; /opt/SYMCsnas/clish/bin/clish -u master -c'; 
my $cmd_nfs_prefix = ' bash -f  /opt/SYMCsnas/scripts/nfs/nfs_agent.sh';

sub mgmt_nfs{
    my ($cmd, $export_dir, $users)=@_;
    my @userList=split(/,/, $users);

    foreach(@userList) {
       my $cmd='';
	if( $_ eq '-')
	{
	 $cmd = $cmd_nfs_prefix." delete "."$export_dir "."\'\*\'";
        }
	else
	{	
         $cmd = $cmd_nfs_prefix." delete "."$export_dir "."\'".$_."\'";
        }
       my @lines = qx/$cmd 2>&1/;
       if ($lines[1] =~ /ERROR/){
           $r=1;
       }
       else
       {
	   $r=0;
       }
    
    lines:
        my $res={};
        my $message={};
        my $js = new JSON;
        if ($r)
        {   
            $status->{status}="ERROR";
            $status->{cmd}='nfs_share_delete';
            $status->{message}= $lines[1];
            $status->{export_dir}=$export_dir;
            $status->{client}=$_;
            if( $_ eq '-')
            {
                $status->{client}='*';

            }
            else
            {
                $status->{client}=$_;

            }
            $res->{header} = $status;
            
            print STDERR $js->objToJson($res);
            exit(1);
        }else{
            $status->{status}= "SUCCESS";
            $status->{cmd}='nfs_share_delete';
            $status->{message}= $lines[1];
            $status->{export_dir}=$export_dir;
            $status->{client}=$_;
            if( $_ eq '-')
            {
                $status->{client}='*';

            }
            else
            {
                $status->{client}=$_;

            }
           $res->{header} = $status;

           printf($js->objToJson($res));
        }
    }
}

sub mgmt_cifs{
    my ($cmd, $users)=@_;
    my @userList=split(/,/, $users);
    foreach(@userList) {
    
    }
}

sub mgmt_s3{
    my ($cmd, $export_dir,$users)=@_;
    my @userList=split(/,/, $users);

    foreach (@userList) {
       my $cmd = $cmd_prefix." \'objectaccess account delete "."$_ $export_dir "."\'";
      
       my @lines = qx/$cmd 2>&1/;
       if ($lines[0] =~ /ERROR/){
          my $messages = `echo "$lines[0]" | awk -F "\"messages\":" '{print \$2}' | awk -F "\"status\":" '{print \$1}'` ; 
          print STDERR $messages;
          exit(1);
       }
       else
       {
          printf($lines[0]);
       }
    }
    
}

sub main
{
    my ($type, $cmd, $export_dir, $users ) = @ARGV;
    
    $ENV{NAS_OUTPUT}='json'; 

    if ($type eq "nfs"){
	mgmt_nfs($_, $export_dir, $users ) 
    }elsif ($type eq "cifs"){
        mgmt_cifs($_, $users );
    }elsif ($type eq "s3"){    
        mgmt_s3($_, $export_dir, $users );
    }else{
        print STDERR "Invalid share type: $type specified";
        exit(1);
    } 
}

main();
