#!/opt/VRTSsfmh/bin/perl

# $Id: isa_snapshot_mgmt.pl, 2016/04/13 21:11:51, Bhushan.Karayilthekkoot $
#
# $Copyright: Copyright (c) 2016 Veritas Technologies LLC.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# VERITAS TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
#
# The  Licensed  Software  and  Documentation  are  deemed  to be commercial
# computer  software  as  defined  in  FAR  12.212 and subject to restricted
# rights  as  defined in FAR Section 52.227-19 "Commercial Computer Software
# - Restricted  Rights"  and  DFARS 227.7202,  et seq.  "Commercial Computer
# Software  and  Commercial Computer Software Documentation," as applicable,
# and any successor regulations, whether delivered by Veritas as on premises
# or  hosted  services.  Any  use,  modification,  reproduction  release,
# performance,  display  or  disclosure  of  the  Licensed  Software  and
# Documentation by the U.S. Government shall be solely in accordance with
# the terms of this Agreement. $
#
#
#
# This script calls clish and returns value depending upon SUCCESS (0)
# or ERROR (1)


#!/opt/VRTSsfmh/bin/perl

BEGIN { unshift(@INC, "/opt/VRTSsfmh/lib/modules"); }

require Exporter;
require VRTS::Paths;
require VRTS::Util;
require VRTS::Agent;
require VRTS::Util;
require VRTS::EXITCODE;
require VRTS::Paths;
require VRTS::Logger;
require VRTS::OS;
require File::Path;
require VRTS::Config;
require VRTS::Task;

my $cmd_prefix = 'source /var/opt/VRTSsfmh/spool/addons/store/VRTSsfmsnas-1.0.0.0/be/cs/utils/unset.sh; source /var/opt/VRTSsfmh/spool/addons/store/VRTSsfmsnas-1.0.0.0/be/cs/utils/myenv.sh; export NAS_OUTPUT=json; /opt/SYMCsnas/scripts/admin/clish_wrapper.sh -u master -c ';

my $cmd_prefix = 'export NAS_OUTPUT=json; /opt/SYMCsnas/clish/bin/clish -u master -c';

sub mgmt_snapshot{
    my ($cmd, $fs_name, $snapshots)=@_;
    my @snapShotList=split(/,/, $snapshots);
    foreach(@snapShotList) {
       my $cmd = $cmd_prefix." \'storage snapshot destroy  "."$_ $fs_name "."\'";
       my @lines = qx/$cmd 2>&1/;
       if ($lines[0] =~ /ERROR/){
           $r=1;
       }
       else
       {
           $r=0;
       }

lines:
    my $res={};
    my $message={};
    my $js = new JSON;
    if ($r)
    {
        $status->{status}="ERROR";
        $status->{cmd}='snapshot_delete';
        $status->{message}= $lines[0];
        $status->{fs_name}=$fs_name;
        $status->{snapshot_name}=$_;
        $res->{header} = $status;
        print STDERR $js->objToJson($res);
        exit(1);
    }else{
        $status->{status}= "SUCCESS";
        $status->{cmd}='snapshot_delete';
        $status->{message}= $lines[0];
       $status->{fs_name}=$fs_name;
        $status->{snapshot_name}=$_;
        
        $res->{header} = $status;

        printf($js->objToJson($res));
    }
}
}

sub main
{
=pod
    $type= snapshot
    $cmd=delete
    $snapshots=comma separated list of snapshots
=cut
    my ($type, $cmd, $snapshots, $fs_name ) = @ARGV;

    $ENV{NAS_OUTPUT}='json';
   
    mgmt_snapshot($_, $fs_name, $snapshots );
    
}

main();

